#include "Drucker.h"

Drucker::Drucker()
{
  
}


Drucker::Drucker(int XmaxK, int YmaxK, int pin_X_01K,int pin_X_02K, int pin_X_03K, int pin_X_04K, int pin_Y_01K, int pin_Y_02K, int pin_Y_03K,int pin_Y_04K, int pin_extruderK, int pin_X_MinusK, int pin_Y_MinusK)
{  
  extruder.attach(pin_extruderK);

  pin_X_01 = pin_X_01K;
  pin_X_02 = pin_X_02K; 
  pin_X_03 = pin_X_03K; 
  pin_X_04 = pin_X_04K;

  pin_Y_01 = pin_Y_01K;
  pin_Y_02 = pin_Y_02K;
  pin_Y_03 = pin_Y_03K;
  pin_Y_04 = pin_Y_04K;

  Xmax = XmaxK;
  Ymax = YmaxK;
  
  pin_X_Minus = pin_X_MinusK;
  pin_Y_Minus = pin_Y_MinusK;

  pinMode(pin_X_01, OUTPUT);
  pinMode(pin_X_02, OUTPUT);
  pinMode(pin_X_03, OUTPUT);
  pinMode(pin_X_04, OUTPUT);

  pinMode(pin_Y_01, OUTPUT);
  pinMode(pin_Y_02, OUTPUT);
  pinMode(pin_Y_03, OUTPUT);
  pinMode(pin_Y_04, OUTPUT);
  
 

  pinMode(pin_X_Minus, INPUT_PULLUP);
  pinMode(pin_Y_Minus, INPUT_PULLUP);

  
}

void Drucker::drawLabyrinth(Point points[], int *pointnumber)
{
  
  double XfieldMax;
  double XfieldMin;
  double YfieldMax;
  double YfieldMin;

  double Xlength;
  double Ylength;
  double FieldLength;

  XfieldMin = points[0].x;
  XfieldMax = points[0].x;
  YfieldMax = points[0].y;
  YfieldMin = points[0].y;


  //sucht nach dem größten feld -> benötigte felder
  for(int i = 0; i <= *pointnumber; i++)
  {
    if(points[i].x > XfieldMax)
    {
      XfieldMax= points[i].x; 
    }
    
    if(points[i].y > YfieldMax)
    {
      YfieldMax = points[i].y; 
    }

    
    if(points[i].y < YfieldMin)
    {
      YfieldMin = points[i].y; 
    }

    
    if(points[i].x < XfieldMin)
    {
      XfieldMin= points[i].x; 
    }
  }

  Xlength = XfieldMax - XfieldMin;
  Ylength = YfieldMax - YfieldMin;

  Xlength ++;
  Ylength ++;
  
  Xlength = (Xmax - 2) / Xlength;    // steht jeweils wie breit ein feld sein muss in bezug auf die maximale druckbare fläche
  Ylength = (Ymax - 2) / Ylength;

  if(Xlength < Ylength)
    FieldLength = Xlength;
  else
    FieldLength = Ylength;

  double XstartPosition;

  // ertse X Koordinate
  //------------------------------------------
  if(XfieldMin < 0)
    XstartPosition = -XfieldMin;
  else
    XstartPosition = XfieldMin;

  XstartPosition += points[0].x;
  XstartPosition *= FieldLength;
  
  
  
  double YstartPosition;
// ertse Y Koordinate
//--------------------------------------------
  if(YfieldMin < 0)
    YstartPosition = -YfieldMin;
  else
    YstartPosition = YfieldMin;

  YstartPosition += points[0].y;
  YstartPosition *= FieldLength;

  

//an Startposition -> malt labyrinthweg
//-----------------------------------------------------

   driveHome();
 //malt die Waende
 //--------------------------------------------------------------------------
  
  int dir;
  
  Serial.println(YstartPosition);
  
  Xturn(XstartPosition + (FieldLength/2), 1);
  Yturn(YstartPosition + (FieldLength/2), 1);

    if(points[0].x < points[1].x)
    {
      dir = 0;
    }
    if(points[0].x > points[1].x)
    {
      dir = 2;
    }

    if(points[0].y < points[1].y)
    {
      dir = 3;
    }
    if(points[0].y > points[1].y)
    {
      dir = 1;
    }

  extrude(0);
  
  for(int i = 1; i < *pointnumber; i++)
  {
    if(points[i-1].x< points[i].x)
    {
      dir = 0;
      Xturn(FieldLength,1);
    }
    if(points[i-1].x > points[i].x)
    {
      dir = 2;
      Xturn(FieldLength,0);
    }

    if(points[i-1].y < points[i].y)
    {
      dir = 3;
      Yturn(FieldLength,1);
    }
    if(points[i-1].y > points[i].y)
    {
      dir = 1;
      Yturn(FieldLength,0);
    }

    if(points[i].x < points[i+1].x) // X+
    {
      if(dir == 0)
        PrintEdge(1, FieldLength);

      if(dir == 2)
      {
        PrintEdge(1, FieldLength);
        PrintEdge(2, FieldLength);
        PrintEdge(3, FieldLength);
      }
      
      if(dir == 1)
      {
        PrintEdge(2, FieldLength);
        PrintEdge(1, FieldLength);
      }
    }

    if(points[i].x > points[i+1].x) // X-
    {
      if(dir == 2)
        PrintEdge(3, FieldLength);
     
      if(dir == 0)
      {
        PrintEdge(3, FieldLength);
        PrintEdge(0, FieldLength);
        PrintEdge(1, FieldLength);
      }
      if(dir == 3)
      {
        PrintEdge(0, FieldLength);
        PrintEdge(3, FieldLength);
      }
    }

    if(points[i].y < points[i+1].y) // Y+
    {
      if(dir == 0)
      {
        PrintEdge(1, FieldLength);
        PrintEdge(0, FieldLength);
      }

      if(dir == 3)
      {
        PrintEdge(0, FieldLength);
      }

      if(dir == 1)
      {
        PrintEdge(0, FieldLength);
        PrintEdge(1, FieldLength);
        PrintEdge(2, FieldLength);
      }
    }

    if(points[i].y > points[i+1].y) // Y-
    {
      if(dir == 2)
      {
        PrintEdge(3, FieldLength);
        PrintEdge(2, FieldLength);
      }
   
      if(dir == 3)
      {
        PrintEdge(0, FieldLength);
        PrintEdge(2, FieldLength);
        PrintEdge(3, FieldLength);
      }

      if(dir == 1)
        PrintEdge(2, FieldLength);
    } 
  }  
  //--------------------------------------------------------------------
  extrude(0);

  driveHome();
  //Yturn(YPos, 0);
  //Xturn(XPos, 0);

  extrude(1);
  delay(3000);
  extrude(0);


  optimizeWay(pointnumber, points);



  //malt den optimalen Weg
  //--------------------------------------------------------------------
  extrude(0);
  Yturn(YstartPosition + (FieldLength/2), 1);
  Xturn(XstartPosition + (FieldLength/2), 1);
  extrude(1);

  
  for(int i = 1; i <= *pointnumber; i++)
  {
    if(points[i-1].x < points[i].x)
    {
      Xturn(FieldLength,1);
    }
    if(points[i-1].x > points[i].x)
    {
      Xturn(FieldLength,0);
    }

    if(points[i-1].y < points[i].y)
    {
      Yturn(FieldLength,1);
    }
    if(points[i-1].y > points[i].y)
    {
      Yturn(FieldLength,0);
    }
  }  
  
  //---------------------------------------------------------------------------
  extrude(0);  
  driveHome();
  
  //Xturn(XPos, 0);
  //Yturn(YPos, 0);
  
  extrude(1);
  delay(3000);
  extrude(0);

   
  //malt die Umwege
  //---------------------------------------------------------------------------
 
  for(int i = 0; i < pointnumberWrong; i++)
  {
    if((pointsWrong[i-1][0] == -5000) || i == 0) // letzte war -5000
    {
    
      Yturn(YstartPosition + (FieldLength/2), 1);
      Xturn(XstartPosition + (FieldLength/2), 1);
      
      Xturn((pointsWrong[i][0] - points[0].x) * FieldLength, 1);
      Yturn((pointsWrong[i][1] - points[0].y) * FieldLength, 1);
      extrude(1);
    }

    if(pointsWrong[i][0] == -5000) // jetztige ist -5000
    {
       extrude(0);
       Xturn(XPos, 0);
       Yturn(YPos, 0);
    }

    if(pointsWrong[i-1][0] != -5000 && pointsWrong[i][0] != -5000 && i != 0) // letzte und jetztige nicht -5000
    {
      if(pointsWrong[i-1][0] < pointsWrong[i][0])
      {
        Xturn(FieldLength,1);
      }
      if(pointsWrong[i-1][0] > pointsWrong[i][0])
      {
        Xturn(FieldLength,0);
      }

      if(pointsWrong[i-1][1] < pointsWrong[i][1])
      {
        Yturn(FieldLength,1);
      }
      if(pointsWrong[i-1][1] > pointsWrong[i][1])
      {
        Yturn(FieldLength,0);
      }
    }
  }
  //--------------------------------------------------------------------------
  
  driveHome();
}

void Drucker::driveHome()
{
  extrude(0);
  grenzen = 0;
  extruderOn = 1;  
  
  while(digitalRead(pin_Y_Minus))
  {
    Yturn(2,0);
    YPos = 0;
  }
  Yturn(5,1);
  while(digitalRead(pin_Y_Minus))
  {
    Yturn(0.1,0);
    YPos = 0;
  }
  
  while(digitalRead(pin_X_Minus))
  {
    Xturn(2,0);
    XPos = 0;
  }

  Xturn(5,1);
  
  while(digitalRead(pin_X_Minus))
  {
    Xturn(0.1,0);
    XPos = 0;
  }

  XPos = 0;
  YPos = 0;
  
  grenzen = 1;
  extruderOn = 0;
}




void Drucker::extrude(bool extrude)
{
  if(extrude == 1)
  {
    extruderOn = 1;
    Yturn(0,0);
    Xturn(0,0);
    extruder.write(40);
  }
  else
  {
    extruderOn = 0;
    extruder.write(80);
  }
  
  delay(25);
}




void Drucker::PrintEdge(int edge, double edgeLength)
{
  if(edge == 0)
  {
    if(distY < 0)
    {
      extrude(0);
      Xturn(edgeLength/2, 1);
      Yturn(edgeLength/2, 1);
      extrude(1);
      Yturn(edgeLength, 0);
      extrude(0);
      Xturn(edgeLength/2, 0);
      Yturn(edgeLength/2, 1);  
    }
    else
    {
      extrude(0);
      Xturn(edgeLength/2, 1);
      Yturn(edgeLength/2, 0);
      extrude(1);
      Yturn(edgeLength, 1);
      extrude(0);
      Xturn(edgeLength/2, 0);
      Yturn(edgeLength/2, 0);
    }
    
  }


  
  if(edge == 1)
  {
    if(distX > 0) // wenn nach x+ fährt
    {
      extrude(0);
      Xturn(edgeLength/2, 0);
      Yturn(edgeLength/2, 0);
      extrude(1);
      Xturn(edgeLength, 1);
      extrude(0);
      Xturn(edgeLength/2, 0);
      Yturn(edgeLength/2, 1);
    }
    else
    {
      extrude(0);
      Xturn(edgeLength/2, 1);
      Yturn(edgeLength/2, 0);
      extrude(1);
      Xturn(edgeLength, 0);
      extrude(0);
      Xturn(edgeLength/2, 1);
      Yturn(edgeLength/2, 1);
    }
    
  }

  
  else if(edge == 2)
  {
    if(distY < 0)
    {
      extrude(0);
      Xturn(edgeLength/2, 0);
      Yturn(edgeLength/2, 1);
      extrude(1);
      Yturn(edgeLength, 0);
      extrude(0);
      Xturn(edgeLength/2, 1);
      Yturn(edgeLength/2, 1);
    }
    else
    {
      extrude(0);
      Xturn(edgeLength/2, 0);
      Yturn(edgeLength/2, 0);
      extrude(1);
      Yturn(edgeLength, 1);
      extrude(0);
      Xturn(edgeLength/2, 1);
      Yturn(edgeLength/2, 0);
    }
    
  }

  
  else if(edge == 3)
  {
    if(distX < 0)
    {
      extrude(0);
      Xturn(edgeLength/2, 1);
      Yturn(edgeLength/2, 1);
      extrude(1);
      Xturn(edgeLength, 0);
      extrude(0);
      Xturn(edgeLength/2, 1);
      Yturn(edgeLength/2, 0);
    }
    else
    {
      extrude(0);
      Xturn(edgeLength/2, 0);
      Yturn(edgeLength/2, 1);
      extrude(1);
      Xturn(edgeLength, 1);
      extrude(0);
      Xturn(edgeLength/2, 0);
      Yturn(edgeLength/2, 0);
    }
  }    
}


void Drucker::optimizeWay(int *pointnumber, Point points[])
{
  for (int i = 0; i <= *pointnumber; i++)
  {
    for (int x = i + 1; x <= *pointnumber; x++)
    {
      if (points[i].x == points [x].x && points[i].y == points[x].y) // geht bis zu gleichem Punkt durch
      {
        int diff = x - i;

       
        
        for (int y = x; y <= *pointnumber || (y-diff) <= x; y++)
        {
          if((y - diff) <= x)
          {
                   
            //speichert die zu löschenden Punkte in PointsWrong
            pointsWrong[pointnumberWrong][0] = points[y - diff].x; 
            pointsWrong[pointnumberWrong][1] = points[y - diff].y;
            pointnumberWrong ++;
          }
         
          //löscht die Punkte in Points
          points[y - diff].x = points[y].x;
          points[y - diff].y = points[y].y;
        }

        pointsWrong[pointnumberWrong][0] = -5000; 
        pointsWrong[pointnumberWrong][1] = -5000;
        pointnumberWrong ++;

        *pointnumber -= diff;

        //x = i+1;
      }
    }
  }
}



void Drucker::Yturn(double dist, bool dir)
{
  //full step 2048

  //durchmesser = 12 => umfang = 37,699111843 mm

  if(dir == 1)
    YPos += dist;
  else
    YPos -= dist;
    
  if((YPos > (Ymax+1) || YPos < -1) && grenzen == 1)
  {
   
    Serial.println("Y OUT!!!");
   
  }
  dist = dist / 37.699111843;
  dist *= 2048;
  dist*= 2;

  if(dir == 0)
    distY -= dist;
  else
    distY += dist;
  
  if(extruderOn == 1)
  {
    if(distY < 0)
    {
      dir = 0;
      distY *=(-1);
    }
    else
    {
      dir = 1;
    }

    for(int i = 0; i < distY; i++)
    {
      switch(YcurPin)
      {
        case 0:
          digitalWrite(pin_Y_01, HIGH);
          digitalWrite(pin_Y_02, LOW);
          digitalWrite(pin_Y_03, LOW);
          digitalWrite(pin_Y_04, LOW);
          break;
                 
         case 1:
          digitalWrite(pin_Y_01, HIGH);
          digitalWrite(pin_Y_02, HIGH);
          digitalWrite(pin_Y_03, LOW);
          digitalWrite(pin_Y_04, LOW);
          break;
    
          case 2:
          digitalWrite(pin_Y_01, LOW);
          digitalWrite(pin_Y_02, HIGH);
          digitalWrite(pin_Y_03, LOW);
          digitalWrite(pin_Y_04, LOW);
          break;
    
          case 3:
          digitalWrite(pin_Y_01, LOW);
          digitalWrite(pin_Y_02, HIGH);
          digitalWrite(pin_Y_03, HIGH);
          digitalWrite(pin_Y_04, LOW);
          break;
    
          case 4:
          digitalWrite(pin_Y_01, LOW);
          digitalWrite(pin_Y_02, LOW);
          digitalWrite(pin_Y_03, HIGH);
          digitalWrite(pin_Y_04, LOW);
          break;
  
          case 5:
          digitalWrite(pin_Y_01, LOW);
          digitalWrite(pin_Y_02, LOW);
          digitalWrite(pin_Y_03, HIGH);
          digitalWrite(pin_Y_04, HIGH);
          break;
    
        case 6:
          digitalWrite(pin_Y_01, LOW);
          digitalWrite(pin_Y_02, LOW);
          digitalWrite(pin_Y_03, LOW);
          digitalWrite(pin_Y_04, HIGH);
          break;
  
        case 7:
          digitalWrite(pin_Y_01, HIGH);
          digitalWrite(pin_Y_02, LOW);
          digitalWrite(pin_Y_03, LOW);
          digitalWrite(pin_Y_04, HIGH);
          break;
          
          default:
          digitalWrite(pin_Y_01, LOW);
          digitalWrite(pin_Y_02, LOW);
          digitalWrite(pin_Y_03, LOW);
          digitalWrite(pin_Y_04, LOW);
      }
    
      if(YcurPin < 7 && dir == 1)
          YcurPin++;
          
      else if(YcurPin > 0 && dir == 0)
          YcurPin--;
      
      else if(YcurPin == 7 && dir == 1)
        YcurPin = 0;
        
      else if(YcurPin == 0 && dir == 0)
        YcurPin = 7;
    
      delayMicroseconds(900);
    }
    digitalWrite(pin_Y_01, LOW);
    digitalWrite(pin_Y_02, LOW);
    digitalWrite(pin_Y_03, LOW);
    digitalWrite(pin_Y_04, LOW);
    
    distY = 0;
  }
}

void Drucker::Xturn(double dist, bool dir)
{
  //full step 2048
  //durchmesser = 12 => umfang = 37,699111843 mm

  if(dir == 1)
    XPos += dist;
  else
    XPos -= dist;
  
  if((XPos > (Xmax+1) || XPos < -0.5) && grenzen == 1)
  {
    //extrude(0);
    
    //driveHome();
    //delay(99999999);
  }
  
  dist = dist / 37.699111843;
  dist *= 2048;
  dist *= 2;

  if(dir == 0)
    distX -= dist;
  else
    distX += dist;
  
  if(extruderOn == 1)
  {
    if(distX < 0)
    {
      dir = 0;
      distX *=(-1);
    }
    else
    {
      dir = 1;
    }

    for(int i = 0; i < distX; i++)
    {
      switch(XcurPin)
      {
        case 0:
          digitalWrite(pin_X_01, HIGH);
          digitalWrite(pin_X_02, LOW);
          digitalWrite(pin_X_03, LOW);
          digitalWrite(pin_X_04, LOW);
          break;
  
        case 1:
          digitalWrite(pin_X_01, HIGH);
          digitalWrite(pin_X_02, HIGH);
          digitalWrite(pin_X_03, LOW);
          digitalWrite(pin_X_04, LOW);
          break;
    
        case 2:
          digitalWrite(pin_X_01, LOW);
          digitalWrite(pin_X_02, HIGH);
          digitalWrite(pin_X_03, LOW);
          digitalWrite(pin_X_04, LOW);
          break;
  
        case 3:
          digitalWrite(pin_X_01, LOW);
          digitalWrite(pin_X_02, HIGH);
          digitalWrite(pin_X_03, HIGH);
          digitalWrite(pin_X_04, LOW);
          break;
    
       case 4:
          digitalWrite(pin_X_01, LOW);
          digitalWrite(pin_X_02, LOW);
          digitalWrite(pin_X_03, HIGH);
          digitalWrite(pin_X_04, LOW);
          break;
  
       case 5:
          digitalWrite(pin_X_01, LOW);
          digitalWrite(pin_X_02, LOW);
          digitalWrite(pin_X_03, HIGH);
          digitalWrite(pin_X_04, HIGH);
          break;
    
       case 6:
          digitalWrite(pin_X_01, LOW);
          digitalWrite(pin_X_02, LOW);
          digitalWrite(pin_X_03, LOW);
          digitalWrite(pin_X_04, HIGH);
          break;
  
       case 7:
          digitalWrite(pin_X_01, HIGH);
          digitalWrite(pin_X_02, LOW);
          digitalWrite(pin_X_03, LOW);
          digitalWrite(pin_X_04, HIGH);
          break;
    
       default:
          digitalWrite(pin_X_01, LOW);
          digitalWrite(pin_X_02, LOW);
          digitalWrite(pin_X_03, LOW);
          digitalWrite(pin_X_04, LOW);
      }
    
      if(XcurPin < 7 && dir == 0)
          XcurPin++;
          
      else if(XcurPin > 0 && dir == 1)
          XcurPin--;
      
      else if(XcurPin == 7 && dir == 0)
        XcurPin = 0;
        
      else if(XcurPin == 0 && dir == 1)
        XcurPin = 7;
    
      delayMicroseconds(900);
    }
    digitalWrite(pin_X_01, LOW);
    digitalWrite(pin_X_02, LOW);
    digitalWrite(pin_X_03, LOW);
    digitalWrite(pin_X_04, LOW);

    distX = 0;
  }
}


