/*full:    400 - 2500
  half:    400 - 6700
  quarter: 400 - 13000

  // grad in grad
  // zeit in millisekunden
  // richtung in true oder false

  drive: 1 = vorne , 2 hinten, 3 rechts 4 links
  drehen: 1 = rechts, 0 = links
*/
#include "Stepper.h"
#include "Drucker.h"
#include <Servo.h>
#include "Common.h"


int robot_direction = 1;
int robot_distance = 0;

Point points[100];

int pointnumber = 0;
int robot_position[2];

bool optimizeDirection = 1;




double rad_Umfang = 15.927874754;

Stepper RadRechts(43, 13, 800);
Stepper RadLinks(42, 12, 800);

Drucker *printer;

int trigger[6];
int echo[6];



void setup() {
  printer = new Drucker(95, 95, 11, 10, 9, 8, 5, 4, 3, 2, 7, 40,41);

  trigger[0] = 45;  // Vorne  
  echo[0] = 44;
  
  trigger[1] = 49;  // Rechts
  echo[1] = 48;

  trigger[3] = 53; // links 
  echo[3] = 52;
 
  trigger[4] = 51;  // vorne links
  echo[4] = 50; 

  trigger[5] = 47;   // vorne rechts 
  echo[5] = 46;

  Serial.begin(9600);

  pinMode(trigger[0], OUTPUT);
  pinMode(echo[0], INPUT);

  pinMode(trigger[1], OUTPUT);
  pinMode(echo[1], INPUT);
  
  pinMode(trigger[2], OUTPUT);
  pinMode(echo[2], INPUT);

  
  pinMode(trigger[3], OUTPUT);
  pinMode(echo[3], INPUT);

  pinMode(trigger[4], OUTPUT);
  pinMode(echo[4], INPUT);

  pinMode(trigger[5], OUTPUT);
  pinMode(echo[5], INPUT);
  
  points[0].x = 0;
  points[0].y = 0;

  
  delay(1500);



  printer->driveHome();
  printer->extrude(1);

  for(int i = 0; i < 95; i++)
  {
    printer->Xturn(1, 1);
    printer->Yturn(1, 1);
  }

  for(int i = 0; i < 95; i++)
  {
    printer->Xturn(1, 0);
    printer->Yturn(1, 0);
  }
  
  delay(999999999);
}



void loop()
{  
  printer->extrude(0);
  printer->extrude(1);
  delay(5000);
  printer->extrude(0);


  while(true)
  {
    if (points[pointnumber].x != -4 ||  points[pointnumber].y != 3)// erstes durchfahren
    {
      scanLabyrinth();// sucht naechsten punkt und speicher ihn ab
    }
    else // wenn durch
    {
      robot_position[0] = points[pointnumber].x;
      robot_position[1] = points[pointnumber].y;
  
      printer->drawLabyrinth(points, &pointnumber);
  
      int LabyLength = pointnumber; // specihert die anzahl der zu fahrenden Felder -> um wieder zurück fahren zu können
  
      while(true)
      {
        pointnumber --;
        
        while(pointnumber >= 0)
        {
          driveBack();
          pointnumber --;
        }
        
        pointnumber = 1;
        
        while(pointnumber <= LabyLength)
        {
          Serial.println("Point!!");
          Serial.println(pointnumber);
          Serial.println(LabyLength);
          driveBack();
          pointnumber ++;
        }
        pointnumber --;
        Serial.println("zurück");
      }
      delay(5000);
    }
  }
}





void driveBack()
{
  int directionRecuire;

  if (robot_position[0] < points[pointnumber].x)
  {
    directionRecuire = 2;
  }

  else if (robot_position[0] > points[pointnumber].x)
  {
    directionRecuire = 4;
  }

  else if (robot_position[1] < points[pointnumber].y)
  {
    directionRecuire = 1;
  }

  else if (robot_position[1] > points[pointnumber].y)
  {
    directionRecuire = 3;
  }

  else
  {
    Serial.println("ERROR!!!");
    delay(9999999);
  }

  while (robot_direction != directionRecuire)
  {
    turn(90, 1);
    //robotdirection 1 nach rechts
    //--------------------------------------------------------

    if (robot_direction < 4)
      robot_direction ++;
    else
      robot_direction = 1;
    //----------------------------------------------------------
  }

  drive(35,1);

  if(getDistance(trigger[0], echo[0]) < 15)
  {
    correctDir();
  }
 /*
  else if(getDistance(trigger[1], echo[1]) < 15)
  {
    turn(90, 1);
    correctDir();
    turn(90, 0);
  }
  else if(getDistance(trigger[3], echo[3]) < 15)
  {
    turn(90, 0);
    correctDir();
    turn(90, 1);
  }
  */
  robot_position[0] = points[pointnumber].x;
  robot_position[1] = points[pointnumber].y;
}

void scanLabyrinth()
{
  while(getDistance(trigger[0], echo[0]) > 6 && robot_distance < 35)  
  {
    drive( 1, 1);
    Serial.println("Fährt");
    robot_distance++;
/*
    if(getDistance(trigger[1], echo[1]) < 5)
      turn(1,0);

    if(getDistance(trigger[3], echo[3]) < 5)
      turn(1,1);  
  */
  }
 
  
  if(getDistance(trigger[0], echo[0]) < 15)
  {
    correctDir();
  }
  //Punkte berechnen
  //---------------------------------------------------------------------
  if (robot_direction == 1) // y+
  {
    points[pointnumber + 1].x = points[pointnumber].x;
    points[pointnumber + 1].y = points[pointnumber].y + 1;
  }
  if (robot_direction == 2) // x+
  {
    points[pointnumber + 1].x = points[pointnumber].x + 1;
    points[pointnumber + 1].y = points[pointnumber].y;
  }

  if (robot_direction == 3) // y-
  {
    points[pointnumber + 1].x = points[pointnumber].x;
    points[pointnumber + 1].y = points[pointnumber].y - 1;
  }

  if (robot_direction == 4) // x-
  {
    points[pointnumber + 1].x = points[pointnumber].x - 1;
    points[pointnumber + 1].y = points[pointnumber].y;
  }
  pointnumber ++;


  //-----------------------------------------------------------------------
  turn(90, 1);

  //robotdirection 1 nach rechts
  //--------------------------------------------------------

  if (robot_direction < 4)
    robot_direction ++;
  else
    robot_direction = 1;
  //----------------------------------------------------------

  robot_distance = 0;

  while (getDistance(trigger[0], echo[0]) < 20)
  {
    if(optimizeDirection == 1)
    {
      correctDir();  
    }
    
    turn(90, 0);
    //robotdirection nach links
    //-------------------------------
    if (robot_direction > 1)
      robot_direction --;
    else
      robot_direction = 4;
    //-------------------------------
  }
  
  if(optimizeDirection == 1)
  {
    // mit hinterer Wand Kalibrieren
    //---------------------------------------------------
    turn(180, 1);
    if (getDistance(trigger[0], echo[0]) < 20)
      correctDir();
    turn(180, 0);
    //---------------------------------------------------
  }
  /*
    Serial.print(pointnumber);
    Serial.print(": ");
    Serial.print(points[pointnumber][0]);
    Serial.print("/");
    Serial.print(points[pointnumber][1]);
    Serial.print("\n");
  */
}

double getDistance(int trig, int ech)
{
  double entfernung = 0;
  double zeit = 0;

  digitalWrite(trig, LOW);
  delay(1);
  digitalWrite(trig, HIGH);
  delayMicroseconds(10);
  digitalWrite(trig, LOW);

  zeit = (double)pulseIn(ech, HIGH);

  zeit /= 2;
  entfernung = zeit / 29.1;
  return (entfernung);
}



// richtung ( 1: vorne, 2 hinten , 3 rechtsDrehen, 4 linksDrehen)
void drive( double distance, int direct)
{
  distance /= rad_Umfang;
  distance *= RadRechts.get_Stepper_Round();

  int beschleunigung = 4000;
  
  if (direct == 1)
  {
    for (int i = 0; i < distance; i++)
    {
      RadRechts.stepp(true);
      RadLinks.stepp(false);
      //delayMicroseconds(1000 + beschleunigung);
      delayMicroseconds(1500);
      if(distance - i < 130)
      {
        beschleunigung += 30;
   
      }
      else if(beschleunigung > 0)
        beschleunigung -= 30;
    }
  }
  else if (direct == 2)
  {
    for (int i = 0; i < distance; i++)
    {
      RadRechts.stepp(false);
      RadLinks.stepp(true);
      delayMicroseconds(1000 + beschleunigung);
      if(distance - i < 130)
      {
        beschleunigung += 30;
      }
      else if(beschleunigung > 0)
        beschleunigung -= 30;
    }
  }

  else if (direct == 3)
  {
    for (int i = 0; i < distance; i++)
    {
      RadRechts.stepp(true);
      RadLinks.stepp(true);
      delayMicroseconds(500 + beschleunigung);
      if(distance - i < 130)
      {
        beschleunigung += 30;
      }
      else if(beschleunigung > 0)
        beschleunigung -= 30;
    }
  }

  else if (direct == 4)
  {
    for (int i = 0; i < distance; i++)
    {
      RadRechts.stepp(false);
      RadLinks.stepp(false);
      delayMicroseconds(500 + beschleunigung);
      if(distance - i < 130)
      {
        beschleunigung += 30;
      }
      else if(beschleunigung > 0)
        beschleunigung -= 30;
    }
  }
}

// 1 = rechts, 0 = links
void turn ( double grad, bool direct)
{
  double wheel_scope = 55.307075111;
  grad /= 360;
  grad *= wheel_scope;

  if (direct == 1)
  {
    drive(grad, 3);
  }
  else
  {
    drive(grad, 4);
  }
}



void correctDir ()
{
//für die ersten 3 Varianten
/*
  double lastdist;
  double curDist;
  bool RightLeft = 0;

  int wrongValue = 0;
  delay(200);
  lastdist = getDistance(trigger[0], echo[0]);

  turn(10, 1);
  delay(200);
  curDist = getDistance(trigger[0], echo[0]);
  turn(10, 0);

  if (lastdist < curDist) // wenn falsche richtung
  {
    RightLeft = 0;
  }
  else
  {
    RightLeft = 1;
  }
*/

  /*
    Serial.println(RightLeft);
    Serial.println(lastdist);
      Serial.println(curDist);
      Serial.println ("\n");
  */


/*
  
    double value = 0;
    int grad = 0;

    turn(10,0);
    turn(45,1);
    value = getDistance(trigger[0], echo[0]);

    for(int i = 0; i < 90; i++)
    {
      turn(1, RightLeft);
      delay(200);
      curDist = getDistance(trigger[0], echo[0]);

      Serial.println(curDist);

      if(value > curDist)
      {
        value = curDist;
        grad = i;
      }
    }

    grad = 90 - grad;
    if(RightLeft == 0)
      RightLeft = 1;
     else
      RightLeft = 0;

    turn(grad, RightLeft);

    Serial.println("\n");
    Serial.println(grad);
    Serial.println(value);
  */
/*
//dreht solange es sich nicht ändert
//------------------------------------------------------------------------------
  do
  {
    delay(20);
    lastdist = getDistance(trigger[0], echo[0]);


    turn( 2, RightLeft);

    delay(100);
    curDist = getDistance(trigger[0], echo[0]);


    if (lastdist < curDist)
    {
      wrongValue ++;
    }
    else
      wrongValue = 0;

  } while (wrongValue < 2);


  while (getDistance(trigger[0], echo[0]) > 5)
  {
    drive(0.1, 1);
  }

  while (getDistance(trigger[0], echo[0]) < 5)
  {
    drive(0.1, 2);
  }
//------------------------------------------------------------------------------
*/
/*
//sucht ein punkt und dreht so weit in die andere Richtung bis die gleiche Entfernung wieder kommt und dreht dann die hälfte wieder zurück
//-------------------------------------------------------------------
  int valueSearch = getDistance(trigger[0], echo[0]);
  int grad = 20;
  turn(20,1);
  bool directionCor;
  delay(30);
  if(valueSearch < getDistance(trigger[0], echo[0]))
  {
    directionCor = 0;
    turn(40, 0);
  }
  else
  {
    directionCor = 1;
  }
  double ValueCur;
  while((ValueCur * 0.95) > valueSearch || (ValueCur * 1.05) < valueSearch)
  {
    turn(1,directionCor);
    grad ++;
    
    if(grad == 60)
    {
      if(directionCor == 1)
        turn(grad - 20, 0);
      if(directionCor == 0)
        turn(grad - 20, 1);
      grad = 20;
    }
    delay(30);
    ValueCur = getDistance(trigger[0], echo[0]);
  }
  if(directionCor == 0)
    directionCor = 1;
   else
    directionCor = 0;
    
  grad/=2;
  turn(grad, directionCor);
  //--------------------------------------------------------------------------------
*/



//mit 2 Sensoren vorne
//----------------------------------------------------
turn(1,0);

  if(getDistance(trigger[5], echo[5]) > getDistance(trigger[4], echo[4]))
  {
    while(getDistance(trigger[5], echo[5]) > getDistance(trigger[4], echo[4]))
    {
      turn(1,0);
    }  
  }
  else
  {
    while(getDistance(trigger[5], echo[5]) < getDistance(trigger[4], echo[4]))
    {
      turn(1,1);
    }
  }

  while (getDistance(trigger[0], echo[0]) > 5)
  {
    drive(0.1, 1);
  }

  while (getDistance(trigger[0], echo[0]) < 5)
  {
    drive(0.1, 2);
  }
}


