#include "Arduino.h"
#include "Stepper.h"

Stepper::Stepper(int directionPin, int stepperPin, int StepsPerRound)
{
	sPin = stepperPin;
	dPin = directionPin;
	stepperRound = StepsPerRound;

	pinMode(dPin, OUTPUT);
	pinMode(sPin, OUTPUT);
}

void Stepper::turn ( float grad, double zeit, bool richtung)
{
	zeit *= 1000;
	
	float steps = grad/360;
	steps *= stepperRound;  
	zeit /= steps;

	if(richtung == true)
	{
		digitalWrite(dPin, HIGH);
	}
	else
	{
		digitalWrite(dPin, LOW);
	}
	
	for(float i = 0; i < steps; i++)
	{
		digitalWrite(sPin, HIGH);
		delayMicroseconds(500);
		digitalWrite(sPin, LOW);
		delayMicroseconds(zeit - 500);
	}
}

void Stepper::stepp(bool direct)
{
  if(direct == true)
  {
    digitalWrite(dPin, HIGH);
  }
  else
  {
    digitalWrite(dPin, LOW);
  }
  
  digitalWrite(sPin, HIGH);
  delayMicroseconds(500);
  digitalWrite(sPin, LOW);
}

int Stepper::get_Stepper_Round ()
{
  return stepperRound;
}

